Skip to main content

Dynamic Programming - Medium Level - Question 2

Dynamic Programming - Medium Level - Question 2


Leetcode 174 Dungeon Game

The demons had captured the princess and imprisoned her in the bottom-right corner of a dungeon. The dungeon consists of m x n rooms laid out in a 2D grid. Our valiant knight was initially positioned in the top-left room and must fight his way through dungeon to rescue the princess.

The knight has an initial health point represented by a positive integer. If at any point his health point drops to 0 or below, he dies immediately.

Some of the rooms are guarded by demons (represented by negative integers), so the knight loses health upon entering these rooms; other rooms are either empty (represented as 0) or contain magic orbs that increase the knight's health (represented by positive integers).

To reach the princess as quickly as possible, the knight decides to move only rightward or downward in each step.

Return the knight's minimum initial health so that he can rescue the princess.

Note that any room can contain threats or power-ups, even the first room the knight enters and the bottom-right room where the princess is imprisoned.

Constraints:

m == dungeon.length

n == dungeon[i].length

1 <= m, n <= 200

-1000 <= dungeon[i][j] <= 1000


Analysis:

If we start from the left top corner to think about this question, it seems not easy... In this kind of situation, what about starting from the last step?

At the last step, without knowing all the previous data, we can calculated the minimum health point when the knight reaches this position.

If the dungeon[m-1][n-1] >= 0, then the minimum value is 1; if negative, it should be 1 - dungeon[m-1][n-1].

This can be the starting point for this question.

If we define f(i, j) is the minimum health point when reaching at location (i, j), then f(i, j) can be derived from f(i+1, j) and f(i, j+1).

int val = min(f(i+1, j), f(i, j+1)) - dungeon[i][j]

If val is positive, (for example when dungeon[i][j] is negative, or smaller than min(f(i+1, j), f(i, j+1)), then f(i, j) should be at least be val; otherwise, f(i, j) can be set as 1, since dungeon[i][j] is large enough for the requirement of next step, f(i+1, j) or f(i, j+1). Thus,

f(i, j) = val <= 0 ? 1 : val

f(0, 0) would be the final result wanted.


See the code below:

class Solution {
public:
    int calculateMinimumHP(vector<vector<int>>& dungeon) {
        if(!dungeon.size() || !dungeon.front().size()) return 0;
        int m = dungeon.size(), n = dungeon.front().size();
        vector<vector<int>> dp(m+1, vector<int>(n+1, INT_MAX));
        dp[m-1][n-1] = dungeon[m-1][n-1] >= 0 ? 1 : 1 - dungeon[m-1][n-1]; 
        for(int i=m-1; i>=0; --i) {
            for(int j=n-1; j>=0; --j) {
                if(i==m-1 && j==n-1) continue;
                int val = min(dp[i+1][j], dp[i][j+1]) - dungeon[i][j];
                dp[i][j] = (val <= 0 ? 1 : val);
            }
        }
        return dp[0][0];
    }
};


Based on the "rolling array" trick, the space complexity can be reduced to O(n). 

See the code below:


class Solution {
public:
    int calculateMinimumHP(vector<vector<int>>& dungeon) {
        if(!dungeon.size() || !dungeon.front().size()) return 0;
        int m = dungeon.size(), n = dungeon.front().size();
        vector<int> dp(n+1, INT_MAX);
        dp[n-1] = dungeon[m-1][n-1] >= 0 ? 1 : 1 - dungeon[m-1][n-1]; 
        for(int i=m-1; i>=0; --i) {
            for(int j=n-1; j>=0; --j) {
                if(i==m-1 && j==n-1) continue;
                int val = min(dp[j], dp[j+1]) - dungeon[i][j];
                dp[j] = (val <= 0 ? 1 : val);
            }
        }
        return dp[0];
    }
};


If still want to start from the left top corner, a different algorithm can be applied: binary search.

The basic idea is that we first make a guess of the initial value: mid. Then we do a check to see whether the knight can reach the end point or not with mid health point. If no, the search range becomes the larger half; if yes, the search range is narrowed down to the smaller half.

See the code below:


class Solution {
public:
    int calculateMinimumHP(vector<vector<int>>& dungeon) {
        if(!dungeon.size() || !dungeon.front().size()) return 1;
        int left = 1, right = INT_MAX;
        while(left < right) {
            int mid = left + (right - left) /2;
            if(!isV(dungeon, mid)) left = mid + 1;
            else right = mid;
        }
        return left;
    }
private:
    bool isV(vector<vector<int>>& vs, int val) {
        int m = vs.size(), n = vs.front().size();
        vector<vector<int>> dp(m+1, vector<int>(n+1, 0));
        dp[1][1] = vs[0][0] + val;
        if(dp[1][1] <= 0) return false;
        for(int i=1; i<=m; ++i) {
            for(int j=1; j<=n; ++j) {
                if(i==1 && j==1) continue;
                int t = max(dp[i][j-1], dp[i-1][j]);
                dp[i][j] = t <= 0 ? -1 : (t + vs[i-1][j-1]);
            }
        }
        return dp[m][n] > 0;
    }
};

Note:

The overall time complexity is O(m*n*log(INT_MAX)), so it is a factor of log(INT_MAX) larger than the dp method above. But this number is smaller, which is ~ 31 or 32.


Upper Layer

Comments

Popular posts from this blog

Segment Tree

Segment tree can be viewed as an abstract data structure which using some more space to trade for speed. For example, for a typical question with O(N^2) time complexity, the segment tree method can decrease it to O(N*log(N)).  To make it understandable, let us consider one example. Say we have an integer array of N size, and what we want is to query the maximum with a query range [idx1, idx2], where idx1 is the left indexes, and idx2 is the right indexes inclusive. If we only do this kind of query once, then we just need to scan through the array from idx1 to idx2 once, and record the maximum, done. The time complexity is O(N), which is decent enough in most cases even though it is not the optimal one (for example, with a segment tree built, the time complexity can decrease down to O(log(N))). However, how about we need to query the array N times? If we continue to use the naïve way above, then the time complexity is O(N^2), since for each query we need to scan the query range once...

Bit Manipulation - Example

  Leetcode 136 Single Number Given a non-empty array of integers nums, every element appears twice except for one. Find that single one. You must implement a solution with a linear runtime complexity and use only constant extra space. Constraints: 1 <= nums.length <= 3 * 10^4 -3 * 10^4 <= nums[i] <= 3 * 10^4 Each element in the array appears twice except for one element which appears only once. Analysis: If there is no space limitation, this question can be solved by counting easily. But counting requires additional space. Here we can use xor (^) operation based on some interesting observations:  A^A = 0, here A is any number A^0 = A, here A is any number Since all the number appears twice except one, then all the number appear even numbers will be cancelled out, and only the number appears one time is left, which is what we want. See the code below: class Solution { public: int singleNumber(vector<int>& nums) { int res = 0; for(auto ...

Rolling Hash

Rolling hash is one common trick used to increase efficiency of substring comparisons by compressing (or hashing) a string into a integer. After this step, we can compare two strings directly without comparing each chars. So the efficiency can be increased from O(N) to O(1). So how to implement the rolling hash? First we need to choose a base for the expansion and a modulo to mod. The basic formula is (suppose the window is n, and the rolling direction is from left to right), HashVal = (A1*p^(n-1) + A2*p^(n-2) + ... + An-1*p^1 + An*p^0)%mod where HashVal is the hash value, Ai is the ith element, p is the base, and mod is the modulo. To avoid collision as much as we can, p and modulo usually need to be large prime numbers. One corner case is that the base order in the above formula cannot be reversed. Or to be more clear, if the rolling direction is from left to right in an array, the first element should be in the highest order of the base, or times p^(n-1), and the last element times ...